# -*- coding: utf-8 -*-
"""
Created on Fri Aug 05 16:23:30 2016

@author: Claire
"""
from lxml import etree
import pandas as pd
import os

## Learn to parse the metadata xml files
#import xmltodict
#d = xmltodict.parse(open('ERS316999.xml', 'r'))

def download_metadata_xmls():
    ## Download all the metadata
    for i in df.index:
        xml = df.loc[i, 'secondary_sample_accession']
        sid = df.loc[i, 'sampleID']
        wgetstr = 'wget -O {}.xml http://www.ebi.ac.uk/ena/data/view/{}%26display%3Dxml'.format(sid,xml)
        os.system(wgetstr)
    return None

def parse_one_xml(xml_file):
    """
    Returns age, bmi, and description metadata in dict form from one xml file
    """
    tree = etree.iterparse(xml_file)
    
    d = dict.fromkeys(['bmi', 'description', 'age'])
    for event, elem in tree:
        if elem.tag == 'SAMPLE_ATTRIBUTE':
            if elem.getchildren()[0].text == "body_mass_index":
                d['bmi'] = elem.getchildren()[1].text
            if elem.getchildren()[0].text == 'description':
                d['description'] = elem.getchildren()[1].text
            if elem.getchildren()[0].text == 'age':
                d['age'] = elem.getchildren()[1].text
    return d
    
if __name__ == "__main__":
    df = pd.read_csv('PRJEB4203.txt', sep='\t')
    ## Add in a sampleID column
    df['sampleID'] = [s.split('/')[-1].split('.')[0].strip('seqs_') for s in df['submitted_ftp']]
    
    #download_metadata_xmls()
        
    ## Parse the metadata 
    files = os.listdir(os.getcwd())
    files = [i for i in files if i.endswith('.xml')]
    
    allmeta = {}
    for f in files:
        sid = f.split('.')[0]
        allmeta[sid] = parse_one_xml(f)
    
    meta = pd.DataFrame(allmeta)
    meta = meta.T

    ## Add some stuff to metadata
    meta['gender'] = [i.split(' ')[1] for i in meta['description']]
    s2d = {'Adequate': 'H', 'Overweight': 'OW', 'Obese': 'OB'}
    meta['DiseaseState'] = [s2d[j.split(' ')[0]] for j in meta['description']]
    meta.to_csv('ob_escobar.metadata.txt', sep='\t')
